package cn.ecpark.service.usergw.config;

import java.lang.reflect.Method;
import java.util.function.BiConsumer;
import java.util.function.Function;

import javax.el.MethodNotFoundException;

import org.apache.dubbo.config.ApplicationConfig;
import org.apache.dubbo.config.ReferenceConfig;
import org.apache.dubbo.rpc.service.GenericService;

import cn.ecpark.service.usergw.utils.Convert;
import lombok.extern.slf4j.Slf4j;

/**
 * ConfigSpecialFunction
 */
@Slf4j
public class ConfigSpecialFunction {

    // public static BiConsumer<ReferenceConfig<GenericService>, String>
    // setApplication = (ref, cfgValue) -> {
    // ref.setApplication(new ApplicationConfig(cfgValue));
    // };

    public static void setApplication(ReferenceConfig<GenericService> ref, String cfgValue) {
        ref.setApplication(new ApplicationConfig(cfgValue));
    }

    public static void setDefault(ReferenceConfig<GenericService> ref, String methodName, String cfgValue) throws Exception {
        cfgValue = "set" + Convert.firstUpperCase(methodName);
        log.info(methodName,cfgValue);
        Method method = ref.getClass().getMethod(methodName);
        method.invoke(ref, cfgValue);
    }
}